diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/wifi-radio-energy-model.cc ns-3.43/src/wifi/model/wifi-radio-energy-model.cc
--- ns-3.42/src/wifi/model/wifi-radio-energy-model.cc	2024-05-29 15:29:47.212073800 -0700
+++ ns-3.43/src/wifi/model/wifi-radio-energy-model.cc	2024-10-09 16:41:10.132656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2010 Network Security Lab, University of Washington, Seattle.
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sidharth Nabar <snabar@uw.edu>, He Wu <mdzz@u.washington.edu>
  */
@@ -46,37 +35,37 @@
                           DoubleValue(0.273), // idle mode = 273mA
                           MakeDoubleAccessor(&WifiRadioEnergyModel::SetIdleCurrentA,
                                              &WifiRadioEnergyModel::GetIdleCurrentA),
-                          MakeDoubleChecker<double>())
+                          MakeDoubleChecker<ampere_u>())
             .AddAttribute("CcaBusyCurrentA",
                           "The default radio CCA Busy State current in Ampere.",
                           DoubleValue(0.273), // default to be the same as idle mode
                           MakeDoubleAccessor(&WifiRadioEnergyModel::SetCcaBusyCurrentA,
                                              &WifiRadioEnergyModel::GetCcaBusyCurrentA),
-                          MakeDoubleChecker<double>())
+                          MakeDoubleChecker<ampere_u>())
             .AddAttribute("TxCurrentA",
                           "The radio TX current in Ampere.",
                           DoubleValue(0.380), // transmit at 0dBm = 380mA
                           MakeDoubleAccessor(&WifiRadioEnergyModel::SetTxCurrentA,
                                              &WifiRadioEnergyModel::GetTxCurrentA),
-                          MakeDoubleChecker<double>())
+                          MakeDoubleChecker<ampere_u>())
             .AddAttribute("RxCurrentA",
                           "The radio RX current in Ampere.",
                           DoubleValue(0.313), // receive mode = 313mA
                           MakeDoubleAccessor(&WifiRadioEnergyModel::SetRxCurrentA,
                                              &WifiRadioEnergyModel::GetRxCurrentA),
-                          MakeDoubleChecker<double>())
+                          MakeDoubleChecker<ampere_u>())
             .AddAttribute("SwitchingCurrentA",
                           "The default radio Channel Switch current in Ampere.",
                           DoubleValue(0.273), // default to be the same as idle mode
                           MakeDoubleAccessor(&WifiRadioEnergyModel::SetSwitchingCurrentA,
                                              &WifiRadioEnergyModel::GetSwitchingCurrentA),
-                          MakeDoubleChecker<double>())
+                          MakeDoubleChecker<ampere_u>())
             .AddAttribute("SleepCurrentA",
                           "The radio Sleep current in Ampere.",
                           DoubleValue(0.033), // sleep mode = 33mA
                           MakeDoubleAccessor(&WifiRadioEnergyModel::SetSleepCurrentA,
                                              &WifiRadioEnergyModel::GetSleepCurrentA),
-                          MakeDoubleChecker<double>())
+                          MakeDoubleChecker<ampere_u>())
             .AddAttribute("TxCurrentModel",
                           "A pointer to the attached TX current model.",
                           PointerValue(),
@@ -120,24 +109,24 @@
     NS_ASSERT(source);
     m_source = source;
     m_switchToOffEvent.Cancel();
-    Time durationToOff = GetMaximumTimeInState(m_currentState);
+    const auto durationToOff = GetMaximumTimeInState(m_currentState);
     m_switchToOffEvent = Simulator::Schedule(durationToOff,
                                              &WifiRadioEnergyModel::ChangeState,
                                              this,
                                              static_cast<int>(WifiPhyState::OFF));
 }
 
-double
+Watt_u
 WifiRadioEnergyModel::GetTotalEnergyConsumption() const
 {
     NS_LOG_FUNCTION(this);
 
-    Time duration = Simulator::Now() - m_lastUpdateTime;
+    const auto duration = Simulator::Now() - m_lastUpdateTime;
     NS_ASSERT(duration.IsPositive()); // check if duration is valid
 
     // energy to decrease = current * voltage * time
-    double supplyVoltage = m_source->GetSupplyVoltage();
-    double energyToDecrease = duration.GetSeconds() * GetStateA(m_currentState) * supplyVoltage;
+    const auto supplyVoltage = m_source->GetSupplyVoltage();
+    const auto energyToDecrease = duration.GetSeconds() * GetStateA(m_currentState) * supplyVoltage;
 
     // notify energy source
     m_source->UpdateEnergySource();
@@ -145,88 +134,88 @@
     return m_totalEnergyConsumption + energyToDecrease;
 }
 
-double
+ampere_u
 WifiRadioEnergyModel::GetIdleCurrentA() const
 {
     NS_LOG_FUNCTION(this);
-    return m_idleCurrentA;
+    return m_idleCurrent;
 }
 
 void
-WifiRadioEnergyModel::SetIdleCurrentA(double idleCurrentA)
+WifiRadioEnergyModel::SetIdleCurrentA(ampere_u idleCurrent)
 {
-    NS_LOG_FUNCTION(this << idleCurrentA);
-    m_idleCurrentA = idleCurrentA;
+    NS_LOG_FUNCTION(this << idleCurrent);
+    m_idleCurrent = idleCurrent;
 }
 
-double
+ampere_u
 WifiRadioEnergyModel::GetCcaBusyCurrentA() const
 {
     NS_LOG_FUNCTION(this);
-    return m_ccaBusyCurrentA;
+    return m_ccaBusyCurrent;
 }
 
 void
-WifiRadioEnergyModel::SetCcaBusyCurrentA(double CcaBusyCurrentA)
+WifiRadioEnergyModel::SetCcaBusyCurrentA(ampere_u ccaBusyCurrent)
 {
-    NS_LOG_FUNCTION(this << CcaBusyCurrentA);
-    m_ccaBusyCurrentA = CcaBusyCurrentA;
+    NS_LOG_FUNCTION(this << ccaBusyCurrent);
+    m_ccaBusyCurrent = ccaBusyCurrent;
 }
 
-double
+ampere_u
 WifiRadioEnergyModel::GetTxCurrentA() const
 {
     NS_LOG_FUNCTION(this);
-    return m_txCurrentA;
+    return m_txCurrent;
 }
 
 void
-WifiRadioEnergyModel::SetTxCurrentA(double txCurrentA)
+WifiRadioEnergyModel::SetTxCurrentA(ampere_u txCurrent)
 {
-    NS_LOG_FUNCTION(this << txCurrentA);
-    m_txCurrentA = txCurrentA;
+    NS_LOG_FUNCTION(this << txCurrent);
+    m_txCurrent = txCurrent;
 }
 
-double
+ampere_u
 WifiRadioEnergyModel::GetRxCurrentA() const
 {
     NS_LOG_FUNCTION(this);
-    return m_rxCurrentA;
+    return m_rxCurrent;
 }
 
 void
-WifiRadioEnergyModel::SetRxCurrentA(double rxCurrentA)
+WifiRadioEnergyModel::SetRxCurrentA(ampere_u rxCurrent)
 {
-    NS_LOG_FUNCTION(this << rxCurrentA);
-    m_rxCurrentA = rxCurrentA;
+    NS_LOG_FUNCTION(this << rxCurrent);
+    m_rxCurrent = rxCurrent;
 }
 
-double
+ampere_u
 WifiRadioEnergyModel::GetSwitchingCurrentA() const
 {
     NS_LOG_FUNCTION(this);
-    return m_switchingCurrentA;
+    return m_switchingCurrent;
 }
 
 void
-WifiRadioEnergyModel::SetSwitchingCurrentA(double switchingCurrentA)
+WifiRadioEnergyModel::SetSwitchingCurrentA(ampere_u switchingCurrent)
 {
-    NS_LOG_FUNCTION(this << switchingCurrentA);
-    m_switchingCurrentA = switchingCurrentA;
+    NS_LOG_FUNCTION(this << switchingCurrent);
+    m_switchingCurrent = switchingCurrent;
 }
 
-double
+ampere_u
 WifiRadioEnergyModel::GetSleepCurrentA() const
 {
     NS_LOG_FUNCTION(this);
-    return m_sleepCurrentA;
+    return m_sleepCurrent;
 }
 
 void
-WifiRadioEnergyModel::SetSleepCurrentA(double sleepCurrentA)
+WifiRadioEnergyModel::SetSleepCurrentA(ampere_u sleepCurrent)
 {
-    NS_LOG_FUNCTION(this << sleepCurrentA);
-    m_sleepCurrentA = sleepCurrentA;
+    NS_LOG_FUNCTION(this << sleepCurrent);
+    m_sleepCurrent = sleepCurrent;
 }
 
 WifiPhyState
@@ -265,11 +254,11 @@
 }
 
 void
-WifiRadioEnergyModel::SetTxCurrentFromModel(double txPowerDbm)
+WifiRadioEnergyModel::SetTxCurrentFromModel(dBm_u txPower)
 {
     if (m_txCurrentModel)
     {
-        m_txCurrentA = m_txCurrentModel->CalcTxCurrent(txPowerDbm);
+        m_txCurrent = m_txCurrentModel->CalcTxCurrent(txPower);
     }
 }
 
@@ -280,9 +269,9 @@
     {
         NS_FATAL_ERROR("Requested maximum remaining time for OFF state");
     }
-    double remainingEnergy = m_source->GetRemainingEnergy();
-    double supplyVoltage = m_source->GetSupplyVoltage();
-    double current = GetStateA(state);
+    const auto remainingEnergy = m_source->GetRemainingEnergy();
+    const auto supplyVoltage = m_source->GetSupplyVoltage();
+    const auto current = GetStateA(state);
     return Seconds(remainingEnergy / (current * supplyVoltage));
 }
 
@@ -304,19 +293,19 @@
     if (newPhyState != WifiPhyState::OFF)
     {
         m_switchToOffEvent.Cancel();
-        Time durationToOff = GetMaximumTimeInState(newPhyState);
+        const auto durationToOff = GetMaximumTimeInState(newPhyState);
         m_switchToOffEvent = Simulator::Schedule(durationToOff,
                                                  &WifiRadioEnergyModel::ChangeState,
                                                  this,
                                                  static_cast<int>(WifiPhyState::OFF));
     }
 
-    Time duration = Simulator::Now() - m_lastUpdateTime;
+    const auto duration = Simulator::Now() - m_lastUpdateTime;
     NS_ASSERT(duration.IsPositive()); // check if duration is valid
 
     // energy to decrease = current * voltage * time
-    double supplyVoltage = m_source->GetSupplyVoltage();
-    double energyToDecrease = duration.GetSeconds() * GetStateA(m_currentState) * supplyVoltage;
+    const auto supplyVoltage = m_source->GetSupplyVoltage();
+    const auto energyToDecrease = duration.GetSeconds() * GetStateA(m_currentState) * supplyVoltage;
 
     // update total energy consumption
     m_totalEnergyConsumption += energyToDecrease;
@@ -380,7 +369,7 @@
     if (m_currentState != WifiPhyState::OFF)
     {
         m_switchToOffEvent.Cancel();
-        Time durationToOff = GetMaximumTimeInState(m_currentState);
+        const auto durationToOff = GetMaximumTimeInState(m_currentState);
         m_switchToOffEvent = Simulator::Schedule(durationToOff,
                                                  &WifiRadioEnergyModel::ChangeState,
                                                  this,
@@ -407,30 +396,30 @@
     m_energyDepletionCallback.Nullify();
 }
 
-double
+ampere_u
 WifiRadioEnergyModel::GetStateA(WifiPhyState state) const
 {
     switch (state)
     {
     case WifiPhyState::IDLE:
-        return m_idleCurrentA;
+        return m_idleCurrent;
     case WifiPhyState::CCA_BUSY:
-        return m_ccaBusyCurrentA;
+        return m_ccaBusyCurrent;
     case WifiPhyState::TX:
-        return m_txCurrentA;
+        return m_txCurrent;
     case WifiPhyState::RX:
-        return m_rxCurrentA;
+        return m_rxCurrent;
     case WifiPhyState::SWITCHING:
-        return m_switchingCurrentA;
+        return m_switchingCurrent;
     case WifiPhyState::SLEEP:
-        return m_sleepCurrentA;
+        return m_sleepCurrent;
     case WifiPhyState::OFF:
         return 0.0;
     }
     NS_FATAL_ERROR("WifiRadioEnergyModel: undefined radio state " << state);
 }
 
-double
+ampere_u
 WifiRadioEnergyModel::DoGetCurrentA() const
 {
     return GetStateA(m_currentState);
@@ -536,14 +525,14 @@
 }
 
 void
-WifiRadioEnergyModelPhyListener::NotifyTxStart(Time duration, double txPowerDbm)
+WifiRadioEnergyModelPhyListener::NotifyTxStart(Time duration, dBm_u txPower)
 {
-    NS_LOG_FUNCTION(this << duration << txPowerDbm);
+    NS_LOG_FUNCTION(this << duration << txPower);
     if (m_updateTxCurrentCallback.IsNull())
     {
         NS_FATAL_ERROR("WifiRadioEnergyModelPhyListener:Update tx current callback not set!");
     }
-    m_updateTxCurrentCallback(txPowerDbm);
+    m_updateTxCurrentCallback(txPower);
     if (m_changeStateCallback.IsNull())
     {
         NS_FATAL_ERROR("WifiRadioEnergyModelPhyListener:Change state callback not set!");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/wifi-radio-energy-model.h ns-3.43/src/wifi/model/wifi-radio-energy-model.h
--- ns-3.42/src/wifi/model/wifi-radio-energy-model.h	2024-05-29 15:29:47.212073800 -0700
+++ ns-3.43/src/wifi/model/wifi-radio-energy-model.h	2024-10-09 16:41:10.132656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2010 Network Security Lab, University of Washington, Seattle.
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Sidharth Nabar <snabar@uw.edu>
  *          He Wu <mdzz@u.washington.edu>
@@ -46,7 +35,7 @@
     /**
      * Callback type for updating the transmit current based on the nominal TX power.
      */
-    typedef Callback<void, double> UpdateTxCurrentCallback;
+    typedef Callback<void, dBm_u> UpdateTxCurrentCallback;
 
     WifiRadioEnergyModelPhyListener();
     ~WifiRadioEnergyModelPhyListener() override;
@@ -68,7 +57,7 @@
     void NotifyRxStart(Time duration) override;
     void NotifyRxEndOk() override;
     void NotifyRxEndError() override;
-    void NotifyTxStart(Time duration, double txPowerDbm) override;
+    void NotifyTxStart(Time duration, dBm_u txPower) override;
     void NotifyCcaBusyStart(Time duration,
                             WifiChannelListType channelType,
                             const std::vector<Time>& per20MhzDurations) override;
@@ -179,85 +168,85 @@
     void SetEnergySource(const Ptr<energy::EnergySource> source) override;
 
     /**
-     * \returns Total energy consumption of the wifi device in watts.
+     * \returns Total energy consumption of the wifi device.
      *
      * Implements DeviceEnergyModel::GetTotalEnergyConsumption.
      */
-    double GetTotalEnergyConsumption() const override;
+    Watt_u GetTotalEnergyConsumption() const override;
 
     // Setter & getters for state power consumption.
     /**
-     * \brief Gets idle current in Amperes.
+     * \brief Gets idle current.
      *
      * \returns idle current of the wifi device.
      */
-    double GetIdleCurrentA() const;
+    ampere_u GetIdleCurrentA() const;
     /**
-     * \brief Sets idle current in Amperes.
+     * \brief Sets idle current.
      *
      * \param idleCurrentA the idle current
      */
-    void SetIdleCurrentA(double idleCurrentA);
+    void SetIdleCurrentA(ampere_u idleCurrentA);
     /**
-     * \brief Gets CCA busy current in Amperes.
+     * \brief Gets CCA busy current.
      *
      * \returns CCA Busy current of the wifi device.
      */
-    double GetCcaBusyCurrentA() const;
+    ampere_u GetCcaBusyCurrentA() const;
     /**
-     * \brief Sets CCA busy current in Amperes.
+     * \brief Sets CCA busy current.
      *
      * \param ccaBusyCurrentA the CCA busy current
      */
-    void SetCcaBusyCurrentA(double ccaBusyCurrentA);
+    void SetCcaBusyCurrentA(ampere_u ccaBusyCurrentA);
     /**
-     * \brief Gets transmit current in Amperes.
+     * \brief Gets transmit current.
      *
      * \returns transmit current of the wifi device.
      */
-    double GetTxCurrentA() const;
+    ampere_u GetTxCurrentA() const;
     /**
-     * \brief Sets transmit current in Amperes.
+     * \brief Sets transmit current.
      *
      * \param txCurrentA the transmit current
      */
-    void SetTxCurrentA(double txCurrentA);
+    void SetTxCurrentA(ampere_u txCurrentA);
     /**
-     * \brief Gets receive current in Amperes.
+     * \brief Gets receive current.
      *
      * \returns receive current of the wifi device.
      */
-    double GetRxCurrentA() const;
+    ampere_u GetRxCurrentA() const;
     /**
-     * \brief Sets receive current in Amperes.
+     * \brief Sets receive current.
      *
      * \param rxCurrentA the receive current
      */
-    void SetRxCurrentA(double rxCurrentA);
+    void SetRxCurrentA(ampere_u rxCurrentA);
     /**
-     * \brief Gets switching current in Amperes.
+     * \brief Gets switching current.
      *
      * \returns switching current of the wifi device.
      */
-    double GetSwitchingCurrentA() const;
+    ampere_u GetSwitchingCurrentA() const;
     /**
-     * \brief Sets switching current in Amperes.
+     * \brief Sets switching current.
      *
      * \param switchingCurrentA the switching current
      */
-    void SetSwitchingCurrentA(double switchingCurrentA);
+    void SetSwitchingCurrentA(ampere_u switchingCurrentA);
     /**
-     * \brief Gets sleep current in Amperes.
+     * \brief Gets sleep current.
      *
      * \returns sleep current of the wifi device.
      */
-    double GetSleepCurrentA() const;
+    ampere_u GetSleepCurrentA() const;
     /**
-     * \brief Sets sleep current in Amperes.
+     * \brief Sets sleep current.
      *
      * \param sleepCurrentA the sleep current
      */
-    void SetSleepCurrentA(double sleepCurrentA);
+    void SetSleepCurrentA(ampere_u sleepCurrentA);
 
     /**
      * \returns Current state.
@@ -287,9 +276,9 @@
      * \brief Calls the CalcTxCurrent method of the TX current model to
      *        compute the TX current based on such model
      *
-     * \param txPowerDbm the nominal TX power in dBm
+     * \param txPower the nominal TX power
      */
-    void SetTxCurrentFromModel(double txPowerDbm);
+    void SetTxCurrentFromModel(dBm_u txPower);
 
     /**
      * \brief Changes state of the WifiRadioEnergyMode.
@@ -338,16 +327,16 @@
 
     /**
      * \param state the wifi state
-     * \returns draw of device in Amperes, at given state.
+     * \returns draw of device at given state.
      */
-    double GetStateA(WifiPhyState state) const;
+    ampere_u GetStateA(WifiPhyState state) const;
 
     /**
-     * \returns Current draw of device in Amperes, at current state.
+     * \returns Current draw of device at current state.
      *
      * Implements DeviceEnergyModel::GetCurrentA.
      */
-    double DoGetCurrentA() const override;
+    ampere_u DoGetCurrentA() const override;
 
     /**
      * \param state New state the radio device is currently in.
@@ -360,12 +349,12 @@
     Ptr<energy::EnergySource> m_source; ///< energy source
 
     // Member variables for current draw in different radio modes.
-    double m_txCurrentA;                      ///< transmit current in Amperes
-    double m_rxCurrentA;                      ///< receive current in Amperes
-    double m_idleCurrentA;                    ///< idle current in Amperes
-    double m_ccaBusyCurrentA;                 ///< CCA busy current in Amperes
-    double m_switchingCurrentA;               ///< switching current in Amperes
-    double m_sleepCurrentA;                   ///< sleep current in Amperes
+    ampere_u m_txCurrent;                     ///< transmit current
+    ampere_u m_rxCurrent;                     ///< receive current
+    ampere_u m_idleCurrent;                   ///< idle current
+    ampere_u m_ccaBusyCurrent;                ///< CCA busy current
+    ampere_u m_switchingCurrent;              ///< switching current
+    ampere_u m_sleepCurrent;                  ///< sleep current
     Ptr<WifiTxCurrentModel> m_txCurrentModel; ///< current model
 
     /// This variable keeps track of the total energy consumed by this model in watts.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/wifi-remote-station-info.cc ns-3.43/src/wifi/model/wifi-remote-station-info.cc
--- ns-3.42/src/wifi/model/wifi-remote-station-info.cc	2024-05-29 15:29:47.212073800 -0700
+++ ns-3.43/src/wifi/model/wifi-remote-station-info.cc	2024-10-09 16:41:10.132656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2005,2006,2007 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/wifi-remote-station-info.h ns-3.43/src/wifi/model/wifi-remote-station-info.h
--- ns-3.42/src/wifi/model/wifi-remote-station-info.h	2024-05-29 15:29:47.212073800 -0700
+++ ns-3.43/src/wifi/model/wifi-remote-station-info.h	2024-10-09 16:41:10.132656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2005,2006,2007 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/wifi-remote-station-manager.cc ns-3.43/src/wifi/model/wifi-remote-station-manager.cc
--- ns-3.42/src/wifi/model/wifi-remote-station-manager.cc	2024-05-29 15:29:47.212073800 -0700
+++ ns-3.43/src/wifi/model/wifi-remote-station-manager.cc	2024-10-09 16:41:10.132656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2005,2006,2007 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
@@ -297,16 +286,16 @@
     return false;
 }
 
-uint16_t
+Time
 WifiRemoteStationManager::GetGuardInterval() const
 {
-    uint16_t gi = 0;
+    Time gi{};
     if (GetHeSupported())
     {
         Ptr<HeConfiguration> heConfiguration = m_wifiPhy->GetDevice()->GetHeConfiguration();
         NS_ASSERT(heConfiguration); // If HE is supported, we should have a HE configuration
                                     // attached
-        gi = static_cast<uint16_t>(heConfiguration->GetGuardInterval().GetNanoSeconds());
+        gi = heConfiguration->GetGuardInterval();
     }
     return gi;
 }
@@ -588,7 +577,7 @@
 }
 
 WifiTxVector
-WifiRemoteStationManager::GetDataTxVector(const WifiMacHeader& header, uint16_t allowedWidth)
+WifiRemoteStationManager::GetDataTxVector(const WifiMacHeader& header, MHz_u allowedWidth)
 {
     NS_LOG_FUNCTION(this << header << allowedWidth);
     Mac48Address address = header.GetAddr1();
@@ -601,7 +590,7 @@
             GetPreambleForTransmission(mode.GetModulationClass(), GetShortPreambleEnabled()));
         v.SetTxPowerLevel(m_defaultTxPowerLevel);
         v.SetChannelWidth(m_wifiPhy->GetTxBandwidth(mode, allowedWidth));
-        v.SetGuardInterval(ConvertGuardIntervalToNanoSeconds(mode, m_wifiPhy->GetDevice()));
+        v.SetGuardInterval(GetGuardIntervalForMode(mode, m_wifiPhy->GetDevice()));
         v.SetNTx(GetNumberOfAntennas());
         v.SetNss(1);
         v.SetNess(0);
@@ -624,10 +613,10 @@
         txVector.SetPreambleType(
             GetPreambleForTransmission(mgtMode.GetModulationClass(), GetShortPreambleEnabled()));
         txVector.SetTxPowerLevel(m_defaultTxPowerLevel);
-        uint16_t channelWidth = allowedWidth;
+        auto channelWidth = allowedWidth;
         if (!header.GetAddr1().IsGroup())
         {
-            if (uint16_t rxWidth = GetChannelWidthSupported(header.GetAddr1());
+            if (const auto rxWidth = GetChannelWidthSupported(header.GetAddr1());
                 rxWidth < channelWidth)
             {
                 channelWidth = rxWidth;
@@ -635,8 +624,7 @@
         }
 
         txVector.SetChannelWidth(m_wifiPhy->GetTxBandwidth(mgtMode, channelWidth));
-        txVector.SetGuardInterval(
-            ConvertGuardIntervalToNanoSeconds(mgtMode, m_wifiPhy->GetDevice()));
+        txVector.SetGuardInterval(GetGuardIntervalForMode(mgtMode, m_wifiPhy->GetDevice()));
     }
     else
     {
@@ -652,7 +640,8 @@
     }
     // If both the allowed width and the TXVECTOR channel width are integer multiple
     // of 20 MHz, then the TXVECTOR channel width must not exceed the allowed width
-    NS_ASSERT_MSG((txVector.GetChannelWidth() % 20 != 0) || (allowedWidth % 20 != 0) ||
+    NS_ASSERT_MSG((static_cast<uint16_t>(txVector.GetChannelWidth()) % 20 != 0) ||
+                      (static_cast<uint16_t>(allowedWidth) % 20 != 0) ||
                       (txVector.GetChannelWidth() <= allowedWidth),
                   "TXVECTOR channel width (" << txVector.GetChannelWidth()
                                              << " MHz) exceeds allowed width (" << allowedWidth
@@ -689,7 +678,7 @@
     return WifiTxVector(defaultMode,
                         GetDefaultTxPowerLevel(),
                         defaultPreamble,
-                        ConvertGuardIntervalToNanoSeconds(defaultMode, m_wifiPhy->GetDevice()),
+                        GetGuardIntervalForMode(defaultMode, m_wifiPhy->GetDevice()),
                         GetNumberOfAntennas(),
                         1,
                         0,
@@ -698,7 +687,7 @@
 }
 
 WifiTxVector
-WifiRemoteStationManager::GetRtsTxVector(Mac48Address address, uint16_t allowedWidth)
+WifiRemoteStationManager::GetRtsTxVector(Mac48Address address, MHz_u allowedWidth)
 {
     NS_LOG_FUNCTION(this << address << allowedWidth);
     WifiTxVector v;
@@ -710,7 +699,7 @@
             GetPreambleForTransmission(mode.GetModulationClass(), GetShortPreambleEnabled()));
         v.SetTxPowerLevel(m_defaultTxPowerLevel);
         v.SetChannelWidth(m_wifiPhy->GetTxBandwidth(mode));
-        v.SetGuardInterval(ConvertGuardIntervalToNanoSeconds(mode, m_wifiPhy->GetDevice()));
+        v.SetGuardInterval(GetGuardIntervalForMode(mode, m_wifiPhy->GetDevice()));
         v.SetNTx(GetNumberOfAntennas());
         v.SetNss(1);
         v.SetNess(0);
@@ -752,9 +741,7 @@
         GetPreambleForTransmission(ctsMode.GetModulationClass(), GetShortPreambleEnabled()));
     v.SetTxPowerLevel(GetDefaultTxPowerLevel());
     v.SetChannelWidth(m_wifiPhy->GetTxBandwidth(ctsMode));
-    uint16_t ctsTxGuardInterval =
-        ConvertGuardIntervalToNanoSeconds(ctsMode, m_wifiPhy->GetDevice());
-    v.SetGuardInterval(ctsTxGuardInterval);
+    v.SetGuardInterval(GetGuardIntervalForMode(ctsMode, m_wifiPhy->GetDevice()));
     v.SetNss(1);
     return v;
 }
@@ -803,9 +790,7 @@
         GetPreambleForTransmission(ackMode.GetModulationClass(), GetShortPreambleEnabled()));
     v.SetTxPowerLevel(GetDefaultTxPowerLevel());
     v.SetChannelWidth(m_wifiPhy->GetTxBandwidth(ackMode));
-    uint16_t ackTxGuardInterval =
-        ConvertGuardIntervalToNanoSeconds(ackMode, m_wifiPhy->GetDevice());
-    v.SetGuardInterval(ackTxGuardInterval);
+    v.SetGuardInterval(GetGuardIntervalForMode(ackMode, m_wifiPhy->GetDevice()));
     v.SetNss(1);
     return v;
 }
@@ -822,9 +807,7 @@
         GetPreambleForTransmission(blockAckMode.GetModulationClass(), GetShortPreambleEnabled()));
     v.SetTxPowerLevel(GetDefaultTxPowerLevel());
     v.SetChannelWidth(m_wifiPhy->GetTxBandwidth(blockAckMode));
-    uint16_t blockAckTxGuardInterval =
-        ConvertGuardIntervalToNanoSeconds(blockAckMode, m_wifiPhy->GetDevice());
-    v.SetGuardInterval(blockAckTxGuardInterval);
+    v.SetGuardInterval(GetGuardIntervalForMode(blockAckMode, m_wifiPhy->GetDevice()));
     v.SetNss(1);
     return v;
 }
@@ -1398,7 +1381,7 @@
     return LookupState(address)->m_info;
 }
 
-std::optional<double>
+std::optional<dBm_u>
 WifiRemoteStationManager::GetMostRecentRssi(Mac48Address address) const
 {
     auto station = Lookup(address);
@@ -1575,12 +1558,12 @@
     }
     if (heCapabilities.GetHeSuPpdu1xHeLtf800nsGi())
     {
-        state->m_guardInterval = 800;
+        state->m_guardInterval = NanoSeconds(800);
     }
     else
     {
         // todo: Using 3200ns, default value for HeConfiguration::GuardInterval
-        state->m_guardInterval = 3200;
+        state->m_guardInterval = NanoSeconds(3200);
     }
     for (const auto& mcs : m_wifiPhy->GetMcsList(WIFI_MOD_CLASS_HE))
     {
@@ -1917,7 +1900,7 @@
                                                 uint16_t nFailedMpdus,
                                                 double rxSnr,
                                                 double dataSnr,
-                                                uint16_t dataChannelWidth,
+                                                MHz_u dataChannelWidth,
                                                 uint8_t dataNss)
 {
     NS_LOG_DEBUG("DoReportAmpduTxStatus received but the manager does not handle A-MPDUs!");
@@ -1973,7 +1956,7 @@
     return station->m_state->m_address;
 }
 
-uint16_t
+MHz_u
 WifiRemoteStationManager::GetChannelWidth(const WifiRemoteStation* station) const
 {
     return station->m_state->m_channelWidth;
@@ -1991,7 +1974,7 @@
     return htCapabilities->GetShortGuardInterval20();
 }
 
-uint16_t
+Time
 WifiRemoteStationManager::GetGuardInterval(const WifiRemoteStation* station) const
 {
     return station->m_state->m_guardInterval;
@@ -2110,7 +2093,7 @@
     return size;
 }
 
-uint16_t
+MHz_u
 WifiRemoteStationManager::GetChannelWidthSupported(Mac48Address address) const
 {
     return LookupState(address)->m_channelWidth;
